function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable @typescript-eslint/no-unused-expressions */
import classNames from 'classnames';
import { fabric } from 'fabric';
import React, { useContext, useEffect, useRef } from 'react';
import { ACTION, CURSOR, IPaintTypes, LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT, paintConfig } from "../constants";
import { EditorContext } from "../util";
import Paint from "./setting/Paint";
import Popover from "./setting/Popover";
export var useCircle = function useCircle() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    currentMenuRef = _useContext.currentMenuRef,
    setCurrentMenu = _useContext.setCurrentMenu,
    canvasIsRender = _useContext.canvasIsRender,
    currentMenu = _useContext.currentMenu,
    historyRef = _useContext.historyRef;
  var startCircle = useRef(false);
  var circlePoint = useRef({
    x: 9,
    y: 0
  });
  var currentCircle = useRef(null);
  var paintConfigValue = useRef({
    color: paintConfig.colors[0],
    size: paintConfig.sizes[0]
  });
  var initCircle = function initCircle() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    canvas.on('mouse:down', function (o) {
      if (canvas.getActiveObject() || currentMenuRef.current !== MENU_TYPE_ENUM.circle) {
        return;
      }
      startCircle.current = true;
      var pointer = canvas.getPointer(o.e);
      circlePoint.current.x = pointer.x;
      circlePoint.current.y = pointer.y;
      currentCircle.current = new fabric.Circle({
        left: circlePoint.current.x,
        top: circlePoint.current.y,
        originX: 'left',
        originY: 'top',
        radius: pointer.x - circlePoint.current.x,
        angle: 0,
        fill: '',
        stroke: paintConfigValue.current.color,
        strokeWidth: paintConfigValue.current.size
      });
      canvas.add(currentCircle.current);
    });
    canvas.on('mouse:move', function (o) {
      if (!canvas.getActiveObject() && currentMenuRef.current === MENU_TYPE_ENUM.circle) {
        canvas.setCursor(CURSOR.crosshair);
      }
      if (!startCircle.current || currentMenuRef.current !== MENU_TYPE_ENUM.circle) {
        canvas.renderAll();
        return;
      }
      var pointer = canvas.getPointer(o.e);
      var radius = Math.max(Math.abs(circlePoint.current.y - pointer.y), Math.abs(circlePoint.current.x - pointer.x)) / 2;
      if (radius > currentCircle.current.strokeWidth) {
        radius -= currentCircle.current.strokeWidth / 2;
      }
      currentCircle.current.set({
        radius: radius
      });
      if (circlePoint.current.x > pointer.x) {
        currentCircle.current.set({
          originX: 'right'
        });
      } else {
        currentCircle.current.set({
          originX: 'left'
        });
      }
      if (circlePoint.current.y > pointer.y) {
        currentCircle.current.set({
          originY: 'bottom'
        });
      } else {
        currentCircle.current.set({
          originY: 'top'
        });
      }
      canvas.renderAll();
    });
    canvas.on('mouse:up', function (o) {
      if (!currentCircle.current || currentMenuRef.current !== MENU_TYPE_ENUM.circle) {
        return;
      }
      var pointer = canvas.getPointer(o.e);
      if (pointer.x === currentCircle.current.left && pointer.y === currentCircle.current.top) {
        /** 无效 */
        canvas.remove(currentCircle.current);
        canvas.requestRenderAll();
        historyRef.current.updateCanvasState(ACTION.add, true, false);
      } else {
        /** 有效 */
        canvas.setActiveObject(currentCircle.current);
        historyRef.current.updateCanvasState(ACTION.add, true, true);
      }
      startCircle.current = false;
      currentCircle.current = null;
    });
  };
  useEffect(function () {
    var canvas = canvasInstanceRef.current;
    if (canvas && canvasIsRender) {
      initCircle();
    }
  }, [canvasInstanceRef, canvasIsRender]);
  var handleDrawCircle = function handleDrawCircle() {
    setCurrentMenu(currentMenuRef.current === MENU_TYPE_ENUM.circle ? MENU_TYPE_ENUM.default : MENU_TYPE_ENUM.circle);
  };
  var handlePaintChange = function handlePaintChange(type, value) {
    if (!canvasInstanceRef.current) {
      return;
    }
    var canvas = canvasInstanceRef.current;
    var activeObject = canvas.getActiveObjects()[0];
    if (type === IPaintTypes.color) {
      paintConfigValue.current.color = value;
      activeObject && activeObject.set('stroke', value);
    } else {
      paintConfigValue.current.size = value;
      activeObject && activeObject.set('strokeWidth', value);
    }
    canvas.renderAll();
  };
  return {
    handleDrawCircle: handleDrawCircle,
    handlePaintChange: handlePaintChange,
    currentMenu: currentMenu
  };
};

/** 圆形 */
export var Circle = function Circle() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang;
  var _useCircle = useCircle(),
    handleDrawCircle = _useCircle.handleDrawCircle,
    handlePaintChange = _useCircle.handlePaintChange,
    currentMenu = _useCircle.currentMenu;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classNames('tie-image-editor_tool-item tie-image-editor_tool-circle', _defineProperty({}, 'tie-image-editor_tool-item--checked', currentMenu === MENU_TYPE_ENUM.circle))
  }, /*#__PURE__*/React.createElement(Paint, {
    open: currentMenu === MENU_TYPE_ENUM.circle,
    onChange: handlePaintChange
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.circle[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: classNames('tie-image-editor_icon'),
    onClick: handleDrawCircle
  })))));
};