function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React, { useContext, useEffect, useRef } from 'react';
import classNames from 'classnames';
import { LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT, WORK_SPACE_ID } from "../constants";
import { EditorContext } from "../util";
import Popover from "./setting/Popover";
export var useDrag = function useDrag() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    wrapperInstanceRef = _useContext.wrapperInstanceRef,
    canvasIsRender = _useContext.canvasIsRender,
    currentMenu = _useContext.currentMenu,
    setCurrentMenu = _useContext.setCurrentMenu;
  var dragModeRef = useRef(false);
  useEffect(function () {
    dragModeRef.current = currentMenu === MENU_TYPE_ENUM.drag;
  }, [setCurrentMenu, currentMenu]);
  var _setDring = function _setDring() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    canvas.selection = false;
    canvas.defaultCursor = 'grab';
    canvas.getObjects().forEach(function (obj) {
      obj.selectable = false;
    });
    canvas.requestRenderAll();
  };
  var startDring = function startDring() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    console.log('startDring');
    setCurrentMenu(MENU_TYPE_ENUM.drag);
    canvas.defaultCursor = 'grab';
    canvas.renderAll();
  };
  var endDring = function endDring() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    setCurrentMenu(MENU_TYPE_ENUM.default);
    canvas.defaultCursor = 'default';
    canvas.isDragging = false;
    canvas.selection = false;
    canvas.renderAll();
  };

  // 拖拽模式;
  var initDring = function initDring() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    canvas.on('mouse:down', function (opt) {
      var evt = opt.e;
      if (evt.altKey || dragModeRef.current) {
        canvas.defaultCursor = 'grabbing';
        canvas.discardActiveObject();
        _setDring();
        canvas.selection = false;
        canvas.isDragging = true;
        canvas.lastPosX = evt.clientX;
        canvas.lastPosY = evt.clientY;
        canvas.requestRenderAll();
      }
    });
    canvas.on('mouse:move', function (opt) {
      if (canvas.isDragging) {
        canvas.discardActiveObject();
        canvas.defaultCursor = 'grabbing';
        var e = opt.e;
        if (!canvas.viewportTransform) return;
        var vpt = canvas.viewportTransform;
        vpt[4] += e.clientX - canvas.lastPosX;
        vpt[5] += e.clientY - canvas.lastPosY;
        canvas.lastPosX = e.clientX;
        canvas.lastPosY = e.clientY;
        canvas.requestRenderAll();
      }
    });
    canvas.on('mouse:up', function () {
      if (!canvas.viewportTransform || !dragModeRef.current) return;
      canvas.setViewportTransform(this.viewportTransform);
      canvas.isDragging = false;
      canvas.selection = true;
      canvas.getObjects().forEach(function (obj) {
        if (obj.id !== WORK_SPACE_ID && obj.hasControls) {
          obj.selectable = true;
        }
      });
      canvas.defaultCursor = 'default';
      canvas.requestRenderAll();
    });
  };
  var handleWrapperKeyDown = function handleWrapperKeyDown(e) {
    /** 空格拖拽功能 */
    var canvas = canvasInstanceRef.current;
    if (e.keyCode === 32 && canvas && !dragModeRef.current) {
      startDring();
    }
    e.preventDefault();
  };
  var handleWrapperKeyUp = function handleWrapperKeyUp(e) {
    /** 结束空格拖拽功能 */
    var canvas = canvasInstanceRef.current;
    if (e.keyCode === 32 && canvas) {
      endDring();
    }
  };
  useEffect(function () {
    if (canvasInstanceRef.current && canvasIsRender) {
      initDring();
      wrapperInstanceRef.current.tabIndex = 1000;
      wrapperInstanceRef.current.addEventListener('keydown', handleWrapperKeyDown, false);
      wrapperInstanceRef.current.addEventListener('keyup', handleWrapperKeyUp, false);
    }
    return function () {
      var canvas = canvasInstanceRef.current;
      if (canvas && wrapperInstanceRef.current) {
        var _wrapperInstanceRef$c, _wrapperInstanceRef$c2;
        (_wrapperInstanceRef$c = wrapperInstanceRef.current) === null || _wrapperInstanceRef$c === void 0 || _wrapperInstanceRef$c.removeEventListener('keydown', handleWrapperKeyDown, false);
        (_wrapperInstanceRef$c2 = wrapperInstanceRef.current) === null || _wrapperInstanceRef$c2 === void 0 || _wrapperInstanceRef$c2.removeEventListener('keyup', handleWrapperKeyUp, false);
      }
    };
  }, [canvasInstanceRef, canvasIsRender]);
  var handleMoving = function handleMoving() {
    setCurrentMenu(currentMenu !== MENU_TYPE_ENUM.drag ? MENU_TYPE_ENUM.drag : MENU_TYPE_ENUM.default);
  };
  return {
    handleMoving: handleMoving,
    currentMenu: currentMenu
  };
};
export var Drag = function Drag() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang;
  var _useDrag = useDrag(),
    handleMoving = _useDrag.handleMoving,
    currentMenu = _useDrag.currentMenu;
  return /*#__PURE__*/React.createElement("div", {
    className: classNames('tie-image-editor_tool-item tie-image-editor_tool-hand', _defineProperty({}, 'tie-image-editor_tool-item--checked', currentMenu === MENU_TYPE_ENUM.drag))
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.drag[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: classNames('tie-image-editor_icon'),
    onClick: handleMoving
  })));
};