function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable @typescript-eslint/no-unused-expressions */
import classNames from 'classnames';
import { fabric } from 'fabric';
import React, { useContext, useRef } from 'react';
import { IPaintTypes, LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT, paintConfig } from "../constants";
import { EditorContext } from "../util";
import Paint from "./setting/Paint";
import Popover from "./setting/Popover";
export var useDraw = function useDraw() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    currentMenuRef = _useContext.currentMenuRef,
    setCurrentMenu = _useContext.setCurrentMenu,
    currentMenu = _useContext.currentMenu;
  var paintConfigValue = useRef({
    color: paintConfig.colors[0],
    size: paintConfig.sizes[0]
  });
  var initDraw = function initDraw() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    canvas.freeDrawingBrush = new fabric['PencilBrush'](canvas);
    var brush = canvas.freeDrawingBrush;
    brush.color = paintConfigValue.current.color;
    if (brush.getPatternSrc) {
      brush.source = brush.getPatternSrc.call(brush);
    }
    brush.width = paintConfigValue.current.size;
    brush.shadow = new fabric.Shadow({
      blur: paintConfigValue.current.size,
      offsetX: 0,
      offsetY: 0,
      affectStroke: true,
      color: '#333'
    });
  };
  var handleDrawTrigger = function handleDrawTrigger() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    if (currentMenuRef.current !== MENU_TYPE_ENUM.draw) {
      canvas.isDrawingMode = true;
      initDraw();
    } else {
      canvas.isDrawingMode = false;
    }
    setCurrentMenu(currentMenuRef.current !== MENU_TYPE_ENUM.draw ? MENU_TYPE_ENUM.draw : MENU_TYPE_ENUM.default);
  };
  var handlePaintChange = function handlePaintChange(type, value) {
    if (!canvasInstanceRef.current) {
      return;
    }
    var canvas = canvasInstanceRef.current;
    var activeObject = canvas.getActiveObjects()[0];
    if (type === IPaintTypes.color) {
      paintConfigValue.current.color = value;
      activeObject && activeObject.set('fill', value);
    } else {
      paintConfigValue.current.size = value;
      activeObject && activeObject.set('width', value);
    }
    canvas.renderAll();
    initDraw();
  };
  return {
    handleDrawTrigger: handleDrawTrigger,
    handlePaintChange: handlePaintChange,
    currentMenu: currentMenu
  };
};
export var Draw = function Draw() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang;
  var _useDraw = useDraw(),
    handleDrawTrigger = _useDraw.handleDrawTrigger,
    handlePaintChange = _useDraw.handlePaintChange,
    currentMenu = _useDraw.currentMenu;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classNames('tie-image-editor_tool-item tie-image-editor_tool-draw', _defineProperty({}, 'tie-image-editor_tool-item--checked', currentMenu === MENU_TYPE_ENUM.draw))
  }, /*#__PURE__*/React.createElement(Paint, {
    open: currentMenu === MENU_TYPE_ENUM.draw,
    onChange: handlePaintChange
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.draw[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: "tie-image-editor_icon",
    onClick: handleDrawTrigger
  })))));
};