function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import classNames from 'classnames';
import React, { useContext, useEffect } from 'react';
import { ACTION, FLIP_TYPE, LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT } from "../constants";
import { EditorContext } from "../util";
import FlipPop from "./setting/FlipPop";
import Popover from "./setting/Popover";
export var useFlip = function useFlip() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    currentMenuRef = _useContext.currentMenuRef,
    setCurrentMenu = _useContext.setCurrentMenu,
    canvasIsRender = _useContext.canvasIsRender,
    currentMenu = _useContext.currentMenu,
    historyRef = _useContext.historyRef;
  useEffect(function () {
    var canvas = canvasInstanceRef.current;
    if (!canvas || !canvasIsRender) {
      return;
    }
  }, [canvasIsRender]);
  var handleFlipTrigger = function handleFlipTrigger() {
    setCurrentMenu(currentMenuRef.current !== MENU_TYPE_ENUM.flip ? MENU_TYPE_ENUM.flip : MENU_TYPE_ENUM.default);
  };
  var handleFlipChange = function handleFlipChange(type, value) {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }

    /** 针对底图翻转的原理是将图标先旋转相反角度，再重新计算坐标，最后翻转 */
    canvas.getObjects().forEach(function (obj) {
      obj.originalPoint = obj.originalPoint || {
        left: obj.left,
        top: obj.top
      };
      var options = _defineProperty({}, type, value);
      if (type === FLIP_TYPE.flipX) {
        if (value) {
          options = _objectSpread(_objectSpread({}, options), {}, {
            left: canvas.width - obj.originalPoint.left - obj.width
          });
        } else {
          options = _objectSpread(_objectSpread({}, options), {}, {
            left: obj.originalPoint.left
          });
        }
      } else {
        if (value) {
          options = _objectSpread(_objectSpread({}, options), {}, {
            top: canvas.height - obj.originalPoint.top - obj.height
          });
        } else {
          options = _objectSpread(_objectSpread({}, options), {}, {
            top: obj.originalPoint.top
          });
        }
      }
      obj.set(options).rotate(parseFloat((obj.angle * -1).toString())).setCoords();
    });
    var canvasImage = canvas.backgroundImage;
    var angle = canvasImage.angle;
    if (value) {
      angle *= -1;
    }
    canvasImage.set(_defineProperty({}, type, value));
    canvasImage.rotate(parseFloat(angle)).setCoords(); // parseFloat for -0 to 0
    canvasImage.setCoords();
    canvas.renderAll();
    historyRef.current.updateCanvasState(ACTION.add);
  };
  return {
    handleFlipTrigger: handleFlipTrigger,
    handleFlipChange: handleFlipChange,
    currentMenu: currentMenu
  };
};
export var Flip = function Flip() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang;
  var _useFlip = useFlip(),
    handleFlipTrigger = _useFlip.handleFlipTrigger,
    handleFlipChange = _useFlip.handleFlipChange,
    currentMenu = _useFlip.currentMenu;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classNames('tie-image-editor_tool-item tie-image-editor_tool-flip', _defineProperty({}, 'tie-image-editor_tool-item--checked', currentMenu === MENU_TYPE_ENUM.flip))
  }, /*#__PURE__*/React.createElement(FlipPop, {
    open: currentMenu === MENU_TYPE_ENUM.flip,
    onChange: handleFlipChange
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.flip[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: "tie-image-editor_icon",
    onClick: handleFlipTrigger
  })))));
};