function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable @typescript-eslint/no-unused-expressions */
import classNames from 'classnames';
import { fabric } from 'fabric';
import React, { useContext, useEffect, useRef } from 'react';
import { ACTION, CURSOR, IPaintTypes, LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT, paintConfig } from "../constants";
import { EditorContext } from "../util";
import Paint from "./setting/Paint";
import Popover from "./setting/Popover";
export var useRect = function useRect() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    currentMenuRef = _useContext.currentMenuRef,
    canvasIsRender = _useContext.canvasIsRender,
    currentMenu = _useContext.currentMenu,
    historyRef = _useContext.historyRef,
    setCurrentMenu = _useContext.setCurrentMenu;
  var startRect = useRef(false);
  var rectPoint = useRef({
    x: 9,
    y: 0
  });
  var currentRect = useRef(null);
  var paintConfigValue = useRef({
    color: paintConfig.colors[0],
    size: paintConfig.sizes[0]
  });

  /** 初始化矩形 */
  var initRect = function initRect() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    canvas.on('mouse:down', function (o) {
      if (canvas.getActiveObject() || currentMenuRef.current !== MENU_TYPE_ENUM.rect) {
        return false;
      }
      startRect.current = true;
      var pointer = canvas.getPointer(o.e);
      rectPoint.current.x = pointer.x;
      rectPoint.current.y = pointer.y;
      currentRect.current = new fabric.Rect({
        left: rectPoint.current.x,
        top: rectPoint.current.y,
        originX: 'left',
        originY: 'top',
        width: pointer.x - rectPoint.current.x,
        height: pointer.y - rectPoint.current.y,
        angle: 0,
        fill: 'rgba(255,0,0,0)',
        stroke: paintConfigValue.current.color,
        strokeWidth: paintConfigValue.current.size,
        transparentCorners: false
      });
      canvas.add(currentRect.current);
    });
    canvas.on('mouse:move', function (o) {
      if (!canvas.getActiveObject() && currentMenuRef.current === MENU_TYPE_ENUM.rect) {
        canvas.setCursor(CURSOR.crosshair);
      }
      if (!startRect.current || !currentRect.current || currentMenuRef.current !== MENU_TYPE_ENUM.rect) {
        canvas.renderAll();
        return;
      }
      var pointer = canvas.getPointer(o.e);
      if (rectPoint.current.x > pointer.x) {
        currentRect.current.set({
          left: Math.abs(pointer.x)
        });
      }
      if (rectPoint.current.y > pointer.y) {
        currentRect.current.set({
          top: Math.abs(pointer.y)
        });
      }
      currentRect.current.set({
        width: Math.abs(rectPoint.current.x - pointer.x)
      });
      currentRect.current.set({
        height: Math.abs(rectPoint.current.y - pointer.y)
      });
      canvas.setCursor(CURSOR.crosshair);
      canvas.renderAll();
    });
    canvas.on('mouse:up', function (o) {
      if (!currentRect.current || currentMenuRef.current !== MENU_TYPE_ENUM.rect) {
        return;
      }
      var pointer = canvas.getPointer(o.e);
      if (pointer.x === currentRect.current.left && pointer.y === currentRect.current.top) {
        /** 无效矩形 */
        canvas.remove(currentRect.current);
        canvas.requestRenderAll();
        historyRef.current.updateCanvasState(ACTION.add, true, false);
      } else {
        /** 有效矩形 */
        canvas.setActiveObject(currentRect.current);
        historyRef.current.updateCanvasState(ACTION.add, true, true);
      }
      startRect.current = false;
      currentRect.current = null;
    });
  };
  useEffect(function () {
    if (canvasInstanceRef.current && canvasIsRender) {
      initRect();
    }
  }, [canvasInstanceRef, canvasIsRender]);
  var handleDrawRect = function handleDrawRect() {
    var newMenu = currentMenuRef.current === MENU_TYPE_ENUM.rect ? MENU_TYPE_ENUM.default : MENU_TYPE_ENUM.rect;
    console.log('currentMenuRef.current', newMenu, currentMenuRef.current);
    setCurrentMenu(newMenu);
  };
  var handlePaintChange = function handlePaintChange(type, value) {
    if (!canvasInstanceRef.current) {
      return;
    }
    var canvas = canvasInstanceRef.current;
    var activeObject = canvas.getActiveObjects()[0];
    if (type === IPaintTypes.color) {
      paintConfigValue.current.color = value;
      activeObject && activeObject.set('stroke', value);
    } else {
      paintConfigValue.current.size = value;
      activeObject && activeObject.set('strokeWidth', value);
    }
    canvas.renderAll();
  };
  return {
    handleDrawRect: handleDrawRect,
    handlePaintChange: handlePaintChange,
    currentMenu: currentMenu
  };
};
export var Rect = function Rect() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang;
  var _useRect = useRect(),
    handleDrawRect = _useRect.handleDrawRect,
    handlePaintChange = _useRect.handlePaintChange,
    currentMenu = _useRect.currentMenu;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classNames('tie-image-editor_tool-item tie-image-editor_tool-rect', _defineProperty({}, 'tie-image-editor_tool-item--checked', currentMenu === MENU_TYPE_ENUM.rect))
  }, /*#__PURE__*/React.createElement(Paint, {
    open: currentMenu === MENU_TYPE_ENUM.rect,
    onChange: handlePaintChange
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.rect[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: classNames('tie-image-editor_icon'),
    onClick: handleDrawRect
  })))));
};