function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { useContext, useEffect } from 'react';
// import { Popover } from '@casstime/bricks';
import classNames from 'classnames';
import { fabric } from 'fabric';
import React from 'react';
import { ACTION, LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT } from "../constants";
import { EditorContext } from "../util";
import Popover from "./setting/Popover";
import RotatePop from "./setting/RotatePop";
export var useRotate = function useRotate() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    currentMenuRef = _useContext.currentMenuRef,
    setCurrentMenu = _useContext.setCurrentMenu,
    canvasIsRender = _useContext.canvasIsRender,
    currentMenu = _useContext.currentMenu,
    historyRef = _useContext.historyRef;
  useEffect(function () {
    var canvas = canvasInstanceRef.current;
    if (!canvas || !canvasIsRender) {
      return;
    }
  }, [canvasIsRender]);
  var handleRotateTrigger = function handleRotateTrigger() {
    setCurrentMenu(currentMenuRef.current !== MENU_TYPE_ENUM.rotate ? MENU_TYPE_ENUM.rotate : MENU_TYPE_ENUM.default);
  };
  var handleRotateChange = function handleRotateChange(value) {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    canvas.getObjects().forEach(function (obj) {
      /** 记录第一次形状的位置，方便计算相对位置 */
      obj.originalPoint = obj.originalPoint || new fabric.Point(obj.left, obj.top);
      var posNewCenter = fabric.util.rotatePoint(obj.originalPoint, canvas.getVpCenter(), fabric.util.degreesToRadians(value));
      obj.set({
        left: posNewCenter.x,
        top: posNewCenter.y,
        angle: value
      });
    });

    /** 单独对背景图进行旋转 */
    var canvasImage = canvas.backgroundImage;
    canvasImage.rotate(value);
    canvasImage.setCoords();
    canvas.requestRenderAll();
    historyRef.current.updateCanvasState(ACTION.add);
  };
  return {
    handleRotateTrigger: handleRotateTrigger,
    handleRotateChange: handleRotateChange,
    currentMenu: currentMenu
  };
};
export var Rotate = function Rotate() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang;
  var _useRotate = useRotate(),
    handleRotateTrigger = _useRotate.handleRotateTrigger,
    handleRotateChange = _useRotate.handleRotateChange,
    currentMenu = _useRotate.currentMenu;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classNames('tie-image-editor_tool-item tie-image-editor_tool-rotate', _defineProperty({}, 'tie-image-editor_tool-item--checked', currentMenu === MENU_TYPE_ENUM.rotate))
  }, /*#__PURE__*/React.createElement(RotatePop, {
    open: currentMenu === MENU_TYPE_ENUM.rotate,
    onChange: handleRotateChange
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.rotate[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: "tie-image-editor_icon",
    onClick: handleRotateTrigger
  })))));
};