function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable @typescript-eslint/no-unused-vars */
import { fabric } from 'fabric';
import React, { useCallback, useContext, useEffect } from 'react';
// import { Popover } from '@casstime/bricks';
import classNames from 'classnames';
import { LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT } from "../constants";
import { EditorContext } from "../util";
import Popover from "./setting/Popover";
import ScalePop from "./setting/ScalePop";
export var useScale = function useScale() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    canvasIsRender = _useContext.canvasIsRender,
    currentMenu = _useContext.currentMenu,
    currentMenuRef = _useContext.currentMenuRef,
    zoom = _useContext.zoom,
    setZoom = _useContext.setZoom,
    setCurrentMenu = _useContext.setCurrentMenu;
  useEffect(function () {
    var canvas = canvasInstanceRef.current;
    if (canvas && canvasIsRender) {
      canvas.on('mouse:wheel', function (opt) {
        var delta = opt.e.deltaY;
        var newZoom = canvas.getZoom();
        newZoom *= Math.pow(0.999, delta);
        if (newZoom > 20) newZoom = 20;
        if (newZoom < 0.01) newZoom = 0.01;
        setZoom(newZoom);
        // const center = canvas.getCenter();
        // canvas.zoomToPoint(new fabric.Point(center.left, center.top), zoom);
        canvas.requestRenderAll();
        opt.e.preventDefault();
        opt.e.stopPropagation();
      });
    }
  }, [canvasInstanceRef, canvasIsRender]);
  useEffect(function () {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    var center = canvas.getCenter();
    canvas.zoomToPoint(new fabric.Point(center.left, center.top), zoom < 0 ? 0.01 : zoom);
    if (currentMenuRef.current !== MENU_TYPE_ENUM.scale) {
      setCurrentMenu(MENU_TYPE_ENUM.scale);
    }
  }, [zoom]);

  /** 放大 */
  var handleScaleUp = function handleScaleUp() {
    if (!canvasInstanceRef.current) {
      return;
    }
    var canvas = canvasInstanceRef.current;
    var zoomRatio = canvas.getZoom();
    zoomRatio += 0.05;
    setZoom(zoomRatio);
    // const center = canvas.getCenter();
    // canvas.zoomToPoint(new fabric.Point(center.left, center.top), zoomRatio);
  };
  /** 缩小 */
  var handleScaleDown = function handleScaleDown() {
    if (!canvasInstanceRef.current) {
      return;
    }
    var canvas = canvasInstanceRef.current;
    var zoomRatio = canvas.getZoom();
    zoomRatio -= 0.05;
    setZoom(zoomRatio);
    // const center = canvas.getCenter();
    // canvas.zoomToPoint(new fabric.Point(center.left, center.top), zoomRatio < 0 ? 0.01 : zoomRatio);
  };

  var handleScaleTrigger = function handleScaleTrigger() {
    setCurrentMenu(currentMenuRef.current === MENU_TYPE_ENUM.scale ? MENU_TYPE_ENUM.default : MENU_TYPE_ENUM.scale);
  };
  var handleReset = function handleReset() {
    setZoom(1);
  };
  var handleOpenChange = useCallback(function (open) {
    setCurrentMenu(!open ? MENU_TYPE_ENUM.default : MENU_TYPE_ENUM.scale);
  }, []);
  return {
    zoom: zoom,
    handleScaleUp: handleScaleUp,
    handleScaleDown: handleScaleDown,
    handleScaleTrigger: handleScaleTrigger,
    handleReset: handleReset,
    handleOpenChange: handleOpenChange
  };
};
export var Scale = function Scale() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang,
    currentMenu = _useContext2.currentMenu;
  var _useScale = useScale(),
    zoom = _useScale.zoom,
    handleScaleDown = _useScale.handleScaleDown,
    handleScaleUp = _useScale.handleScaleUp,
    handleScaleTrigger = _useScale.handleScaleTrigger,
    handleReset = _useScale.handleReset,
    handleOpenChange = _useScale.handleOpenChange;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classNames('tie-image-editor_tool-item tie-image-editor_tool-zoomIn', _defineProperty({}, 'tie-image-editor_tool-item--checked', currentMenu === MENU_TYPE_ENUM.scale))
  }, /*#__PURE__*/React.createElement(ScalePop, {
    open: currentMenu === MENU_TYPE_ENUM.scale,
    zoom: zoom,
    onScaleDown: handleScaleDown,
    onScaleUp: handleScaleUp,
    onReset: handleReset,
    onOpenChange: handleOpenChange
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.scale[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: classNames('tie-image-editor_icon')
    // onClick={handleScaleTrigger}
  })))));
};