function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable @typescript-eslint/no-unused-expressions */
import { fabric } from 'fabric';
import React, { useCallback, useContext, useEffect, useRef } from 'react';
// import { Popover } from '@casstime/bricks';
import classNames from 'classnames';
import { IPaintTypes, LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT, paintConfig } from "../constants";
import { EditorContext } from "../util";
import Paint from "./setting/Paint";
import Popover from "./setting/Popover";
export var useText = function useText() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    currentMenuRef = _useContext.currentMenuRef,
    setCurrentMenu = _useContext.setCurrentMenu,
    canvasIsRender = _useContext.canvasIsRender,
    currentMenu = _useContext.currentMenu;
  var paintConfigValue = useRef({
    color: paintConfig.colors[0],
    size: paintConfig.fontSizes[0]
  });
  var isSelectingText = useRef(false);
  var mouseup = useCallback(function (o) {
    var canvas = canvasInstanceRef.current;
    if (!canvas || o.target) {
      return;
    }
    if (isSelectingText.current) {
      isSelectingText.current = false;
      return;
    }
    if (canvas.getActiveObject() || currentMenuRef.current !== MENU_TYPE_ENUM.text) {
      return;
    }
    var pointer = canvas.getPointer(o.e);
    var text = new fabric.IText('输入内容', {
      left: pointer.x,
      top: pointer.y,
      fontSize: paintConfigValue.current.size,
      id: Math.random() * 4 + '_' + Date.now(),
      fill: paintConfigValue.current.color
    });
    canvas.add(text);
    canvas.setActiveObject(text);
    isSelectingText.current = true;
    canvas.renderAll();
  }, []);
  var initText = function initText() {
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }
    canvas.on('mouse:up', mouseup);
  };
  useEffect(function () {
    var canvas = canvasInstanceRef.current;
    if (!canvas || !canvasIsRender) {
      return;
    }
    initText();
    return function () {
      canvas.off('mouse:up', mouseup);
    };
  }, [canvasIsRender]);
  var handleTextTrigger = function handleTextTrigger() {
    setCurrentMenu(currentMenuRef.current !== MENU_TYPE_ENUM.text ? MENU_TYPE_ENUM.text : MENU_TYPE_ENUM.default);
  };
  var handlePaintChange = function handlePaintChange(type, value) {
    if (!canvasInstanceRef.current) {
      return;
    }
    var canvas = canvasInstanceRef.current;
    var activeObject = canvas.getActiveObjects()[0];
    if (type === IPaintTypes.color) {
      paintConfigValue.current.color = value;
      activeObject && activeObject.set('fill', value);
    } else {
      paintConfigValue.current.size = value;
      activeObject && activeObject.set('fontSize', value);
    }
    canvas.renderAll();
  };
  return {
    handleTextTrigger: handleTextTrigger,
    handlePaintChange: handlePaintChange,
    currentMenu: currentMenu
  };
};
export var Text = function Text() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang;
  var _useText = useText(),
    handleTextTrigger = _useText.handleTextTrigger,
    handlePaintChange = _useText.handlePaintChange,
    currentMenu = _useText.currentMenu;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classNames('tie-image-editor_tool-item tie-image-editor_tool-text', _defineProperty({}, 'tie-image-editor_tool-item--checked', currentMenu === MENU_TYPE_ENUM.text))
  }, /*#__PURE__*/React.createElement(Paint, {
    open: currentMenu === MENU_TYPE_ENUM.text,
    onChange: handlePaintChange,
    type: MENU_TYPE_ENUM.text
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.text[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: "tie-image-editor_icon",
    onClick: handleTextTrigger
  })))));
};