// import { Popover } from '@casstime/bricks';
import React, { useContext } from 'react';
import { ACTION, LANG, MENU_TYPE_ENUM, MENU_TYPE_TEXT } from "../constants";
import { EditorContext } from "../util";
import Popover from "./setting/Popover";
var useUpload = function useUpload() {
  var _useContext = useContext(EditorContext),
    canvasInstanceRef = _useContext.canvasInstanceRef,
    canvasEl = _useContext.canvasEl,
    currentMenuRef = _useContext.currentMenuRef,
    historyRef = _useContext.historyRef,
    setCurrentMenu = _useContext.setCurrentMenu,
    initBackGroundImage = _useContext.initBackGroundImage;
  var handleUpload = function handleUpload(e) {
    var _e$target$files$;
    var canvas = canvasInstanceRef.current;
    if (!canvas || !canvasEl.current || !e.target.files.length || !((_e$target$files$ = e.target.files[0]) !== null && _e$target$files$ !== void 0 && (_e$target$files$ = _e$target$files$.type) !== null && _e$target$files$ !== void 0 && _e$target$files$.includes('image'))) {
      return;
    }
    if (currentMenuRef.current !== MENU_TYPE_ENUM.upload) {
      setCurrentMenu(MENU_TYPE_ENUM.upload);
    }
    var reader = new FileReader();
    reader.onload = function (event) {
      if (!event || !event.target) {
        return;
      }
      var imgObj = new Image();
      imgObj.src = event.target.result;
      initBackGroundImage(event.target.result, true, function () {
        historyRef.current.updateCanvasState(ACTION.add);
      });
    };
    reader.readAsDataURL(e.target.files[0]);
  };
  return {
    handleUpload: handleUpload
  };
};

/** 上传 */
export var Upload = function Upload() {
  var _useContext2 = useContext(EditorContext),
    _useContext2$lang = _useContext2.lang,
    lang = _useContext2$lang === void 0 ? LANG.en : _useContext2$lang;
  var _useUpload = useUpload(),
    handleUpload = _useUpload.handleUpload;
  return /*#__PURE__*/React.createElement("div", {
    className: "tie-image-editor_tool-item tie-image-editor_tool-upload"
  }, /*#__PURE__*/React.createElement(Popover, {
    content: MENU_TYPE_TEXT.upload[lang],
    placement: "top"
  }, /*#__PURE__*/React.createElement("i", {
    className: "tie-image-editor_icon"
  }, /*#__PURE__*/React.createElement("input", {
    onChange: handleUpload,
    type: "file",
    className: "tie-image-editor_tool-upload-input",
    accept: "image/*"
  }))));
};