function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/* eslint-disable @typescript-eslint/no-unused-expressions */
import { fabric } from 'fabric';
import { useEffect, useRef, useState } from 'react';
import { CURSOR, MENU_TYPE_ENUM, WORK_SPACE_ID, stayRemain } from "../constants";
/** 初始化图像编辑组件 */
export var useInit = function useInit(_ref) {
  var url = _ref.url;
  var canvasEl = useRef(null);
  var imageInstanceRef = useRef();
  var canvasInstanceRef = useRef();
  var wrapperInstanceRef = useRef(null);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    canvasIsRender = _useState2[0],
    setCanvasIsRender = _useState2[1];

  /** 当前菜单 */
  var _useState3 = useState(MENU_TYPE_ENUM.default),
    _useState4 = _slicedToArray(_useState3, 2),
    currentMenu = _useState4[0],
    _setCurrentMenu = _useState4[1];
  var currentMenuRef = useRef(MENU_TYPE_ENUM.default);

  /** canvas 初始化 */
  var initCanvasJson = useRef('{}');

  /** 不应该保存历史 */
  var unSaveHistory = useRef(false);

  /** 历史实例 */
  var historyRef = useRef({
    updateCanvasState: function updateCanvasState() {}
  });

  /** 下载 */
  var downloadRef = useRef({
    downLoad: function downLoad() {
      return Promise.resolve({});
    }
  });

  /** 缩放比例 */
  var _useState5 = useState(1),
    _useState6 = _slicedToArray(_useState5, 2),
    zoom = _useState6[0],
    setZoom = _useState6[1];

  /** 更新菜单 */
  var setCurrentMenu = function setCurrentMenu(newMenu) {
    console.log('setCurrentMenu', newMenu);
    _setCurrentMenu(newMenu);
    currentMenuRef.current = newMenu;
    var canvas = canvasInstanceRef.current;
    if (!canvas) {
      return;
    }

    /** 清空自由画状态 */
    if (![MENU_TYPE_ENUM.draw, MENU_TYPE_ENUM.mosaic].includes(newMenu)) {
      canvas.isDrawingMode = false;
    }

    /** 矩形 */
    if ([MENU_TYPE_ENUM.rect, MENU_TYPE_ENUM.circle, MENU_TYPE_ENUM.arrow].includes(newMenu)) {
      canvas.setCursor(CURSOR.crosshair);
    } else if ([MENU_TYPE_ENUM.rect, MENU_TYPE_ENUM.circle, MENU_TYPE_ENUM.arrow].includes(currentMenuRef.current)) {
      canvas.setCursor(CURSOR.default);
    }
    canvas.renderAll();
  };

  /** 初始化画布 */
  var initCanvas = function initCanvas() {
    if (wrapperInstanceRef.current && canvasEl.current) {
      try {
        var _wrapperInstanceRef$c = wrapperInstanceRef.current.getBoundingClientRect(),
          width = _wrapperInstanceRef$c.width,
          height = _wrapperInstanceRef$c.height;
        var canvas = new fabric.Canvas(canvasEl.current, {
          containerClass: 'tie-image-editor_canvas',
          // enableRetinaScaling: false,
          // isDrawingMode: true,
          // fireRightClick: true, // 启用右键，button的数字为3
          // stopContextMenu: true, // 禁止默认右键菜单
          // controlsAboveOverlay: true, // 超出clipPath后仍然展示控制条
          width: width,
          height: height
        });
        canvasInstanceRef.current = canvas;
        /** 通知其他组件，canvas已经实例化 */
        setCanvasIsRender(true);
        try {
          /** 第一次初始化 */
          initCanvasJson.current = JSON.stringify(canvas.toJSON(stayRemain));
        } catch (error) {
          console.error('initCanvasJson 初始化失败');
        }
      } catch (error) {
        console.error(error);
      }
    }
  };

  /** 初始化背景图 */
  var initBackGroundImage = function initBackGroundImage() {
    var imageUrl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    var justBackground = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var callback = arguments.length > 2 ? arguments[2] : undefined;
    var canvas = canvasInstanceRef.current;
    if (imageUrl.trim() && canvas && wrapperInstanceRef.current) {
      var _wrapperInstanceRef$c2 = wrapperInstanceRef.current.getBoundingClientRect(),
        height = _wrapperInstanceRef$c2.height;
      imageInstanceRef.current = fabric.Image.fromURL(imageUrl, function (oImg) {
        var center = canvas.getCenter();
        var imgHeight = oImg.height;
        /** 图片过大，使其大小正好跟容器一致 */
        oImg.scale(height / imgHeight);
        /** 使得图片在canvas中间 */
        oImg.set({
          left: center.left - oImg.width * (height / imgHeight) / 2,
          top: center.top - oImg.height * (height / imgHeight) / 2
        });
        /** 不让直接操作图片 */
        oImg.selectable = false;
        oImg.id = WORK_SPACE_ID;
        canvas.setBackgroundImage(oImg, canvas.renderAll.bind(canvas));

        /** 仅仅替换背景 */
        if (justBackground) {
          callback && callback();
          return;
        }
        try {
          /** 加载图片后再初始化一次 */
          initCanvasJson.current = JSON.stringify(canvas.toJSON(stayRemain));
        } catch (error) {
          console.error('initCanvasJson 初始化失败');
        }
        callback && callback();
      }, {
        crossOrigin: 'anonymous'
      });
    }
  };
  useEffect(function () {
    initCanvas();
  }, [canvasEl, wrapperInstanceRef]);
  useEffect(function () {
    initBackGroundImage(url);
  }, [url, canvasInstanceRef, wrapperInstanceRef]);
  return {
    canvasEl: canvasEl,
    imageInstanceRef: imageInstanceRef,
    canvasInstanceRef: canvasInstanceRef,
    wrapperInstanceRef: wrapperInstanceRef,
    currentMenu: currentMenu,
    setCurrentMenu: setCurrentMenu,
    currentMenuRef: currentMenuRef,
    canvasIsRender: canvasIsRender,
    initCanvasJson: initCanvasJson,
    unSaveHistory: unSaveHistory,
    historyRef: historyRef,
    initBackGroundImage: initBackGroundImage,
    downloadRef: downloadRef,
    zoom: zoom,
    setZoom: setZoom
  };
};