import React from 'react';
import { IDOMProps } from '../../constants';
export type Placement = 'auto' | 'auto-start' | 'auto-end' | 'top' | 'top-start' | 'top-end' | 'bottom' | 'bottom-start' | 'bottom-end' | 'right' | 'right-start' | 'right-end' | 'left' | 'left-start' | 'left-end';
export interface IPopoverProps extends IDOMProps {
    className?: string;
    popoverClassName?: string;
    style?: React.CSSProperties;
    popoverStyle?: React.CSSProperties;
    open?: boolean;
    placement?: Placement;
    positionFixed?: boolean;
    children: React.ReactNode;
    showArrow?: boolean;
    usePortal?: boolean;
    /** 自定义Portal容器节点 */
    portalContainer?: Element;
    content: React.ReactNode;
    modifiers?: Array<Object>;
    outlineColor?: string;
    backgroundColor?: string;
    trigger?: 'click' | 'focus' | 'hover';
    visible?: boolean;
    scheduleUpdate?: boolean;
    getPopoverRef?: (ref: React.RefObject<HTMLDivElement>) => void;
    onOpenChange?: (visible: boolean) => void;
    /** 点击空白区域，自动关闭popover */
    maskClosable?: boolean;
}
declare const Popover: {
    (props: IPopoverProps): React.JSX.Element;
    defaultProps: {
        visible: boolean;
        trigger: string;
        placement: string;
        showArrow: boolean;
        usePortal: boolean;
        modifiers: never[];
    };
};
export default Popover;
