/// <reference types="react" />
export declare const eventNames: {
    OBJECT_ACTIVATED: string;
    OBJECT_MOVED: string;
    OBJECT_SCALED: string;
    OBJECT_CREATED: string;
    TEXT_EDITING: string;
    TEXT_CHANGED: string;
    ICON_CREATE_RESIZE: string;
    ICON_CREATE_END: string;
    ADD_TEXT: string;
    ADD_OBJECT: string;
    ADD_OBJECT_AFTER: string;
    MOUSE_DOWN: string;
    MOUSE_UP: string;
    MOUSE_MOVE: string;
    REDO_STACK_CHANGED: string;
    UNDO_STACK_CHANGED: string;
    SELECTION_CLEARED: string;
    SELECTION_CREATED: string;
};
/** 菜单 */
export declare enum MENU_TYPE_ENUM {
    crop = "crop",
    history = "history",
    download = "download",
    draw = "draw",
    flip = "flip",
    reset = "reset",
    rotate = "rotate",
    rect = "rect",
    circle = "circle",
    text = "text",
    upload = "upload",
    drag = "drag",
    scale = "scale",
    arrow = "arrow",
    mosaic = "mosaic",
    undo = "undo",
    redo = "redo",
    default = ""
}
export declare enum LANG {
    zh = "zh",
    en = "en"
}
export declare const MENU_TYPE_TEXT: {
    [key: string]: {
        [LANG.zh]: string;
        [LANG.en]: string;
    };
};
/** 鼠标形状 */
export declare enum CURSOR {
    default = "default",
    crosshair = "crosshair",
    pointer = "pointer",
    move = "move",
    grab = "grab",
    grabbing = "grabbing",
    zoomIn = "zoom-in",
    zoomOut = "zoom-out"
}
export declare enum ACTION {
    add = "add",
    modified = "modified",
    delete = "delete"
}
export declare const ACTION_TEXT: {
    [key: string]: string;
};
export declare enum FLIP_TYPE {
    flipX = "flipX",
    flipY = "flipY"
}
export declare const WORK_SPACE_ID = "workspace";
export declare enum IPaintTypes {
    size = "size",
    color = "color"
}
/** 一些绘画配置 */
export declare const paintConfig: {
    sizes: number[];
    colors: string[];
    fontSizes: number[];
    rotates: number[];
    mosaicSizes: number[];
};
/** 下载函数参数 */
export interface IDownloadBody {
    downLoadUrl?: string;
}
export interface IEditorProps {
    url?: string;
    style?: React.CSSProperties;
    menus?: MENU_TYPE_ENUM[];
    lang?: LANG;
    onDownLoad?: (param: IDownloadBody) => void;
}
export declare const keyCodes: {
    Z: number;
    Y: number;
    SHIFT: number;
    BACKSPACE: number;
    DEL: number;
};
export declare const IMAGE_NAME = "tie_image_editor";
export declare const DEFAULT_DIMENSION = 8;
/** 前进和回退时保留的属性 */
export declare const stayRemain: string[];
/** 最大历史长度 */
export declare const MAX_HISTORY_LEN = 30;
/** 空值 */
export declare const EMPTY_STR = "";
export declare const EMPTY_ARR: never[];
/** 原生dom事件的interface */
export type IDOMProps = React.DOMAttributes<HTMLElement>;
/** 通用的需要从 props 过滤掉的不属于 dom 的属性 */
export declare const INVALID_PROPS: string[];
