import React from 'react';
import { ACTION, IEditorProps, MENU_TYPE_ENUM } from './constants';
export interface IEditorContextProps extends IEditorProps {
    canvasInstanceRef: React.MutableRefObject<any>;
    wrapperInstanceRef: React.MutableRefObject<any>;
    currentMenuRef: React.MutableRefObject<MENU_TYPE_ENUM>;
    currentMenu: MENU_TYPE_ENUM;
    setCurrentMenu: (value: MENU_TYPE_ENUM) => void;
    canvasIsRender: boolean;
    canvasEl: React.MutableRefObject<any>;
    initCanvasJson: React.MutableRefObject<any>;
    unSaveHistory: React.MutableRefObject<any>;
    historyRef: React.MutableRefObject<any>;
    zoom: number;
    setZoom: (zoom: number) => void;
    initBackGroundImage: (imageUrl: string, justBackground: boolean, callback?: () => void) => void;
}
export declare const EditorContext: React.Context<IEditorContextProps>;
export interface IHistory {
    id: string;
    data: string;
    type: MENU_TYPE_ENUM;
    action: ACTION;
}
export declare const isSupportFileApi: () => boolean;
export declare const base64ToBlob: (data: any) => Blob;
export declare const clamp: (value: number, minValue: number, maxValue: number) => number;
export declare const omit: <T extends {
    [key: string]: any;
}>(object: T, array: string[]) => T;
/**
 * 移除非 Dom 属性的 props 的值
 * @param props 需要过滤 props 的属性
 * @param {string[]} invalidProps 需要从 props 过滤掉的不属于 dom 的属性.
 */
export declare function removeNonHTMLProps(props: {
    [key: string]: any;
}, invalidProps?: string[]): {
    [key: string]: any;
};
/**获取IE浏览器版本 */
export declare const getIEVersion: () => number | undefined;
