import React from 'react';
import { INVALID_PROPS, MENU_TYPE_ENUM } from "./constants";
export var EditorContext = /*#__PURE__*/React.createContext({
  canvasInstanceRef: {
    current: null
  },
  wrapperInstanceRef: {
    current: null
  },
  currentMenuRef: {
    current: MENU_TYPE_ENUM.default
  },
  currentMenu: MENU_TYPE_ENUM.default,
  setCurrentMenu: function setCurrentMenu() {},
  canvasIsRender: false,
  canvasEl: {
    current: null
  },
  initCanvasJson: {
    current: null
  },
  unSaveHistory: {
    current: null
  },
  historyRef: {
    current: function current() {}
  },
  initBackGroundImage: function initBackGroundImage() {},
  zoom: 1,
  setZoom: function setZoom() {}
});
export var isSupportFileApi = function isSupportFileApi() {
  return !!(window.File && window.FileList && window.FileReader);
};
export var base64ToBlob = function base64ToBlob(data) {
  var rImageType = /data:(image\/.+);base64,/;
  var mimeString = '';
  var raw, uInt8Array, i;
  raw = data.replace(rImageType, function (header, imageType) {
    mimeString = imageType;
    return '';
  });
  raw = atob(raw);
  var rawLength = raw.length;
  uInt8Array = new Uint8Array(rawLength); // eslint-disable-line

  for (i = 0; i < rawLength; i += 1) {
    uInt8Array[i] = raw.charCodeAt(i);
  }
  return new Blob([uInt8Array], {
    type: mimeString
  });
};
export var clamp = function clamp(value, minValue, maxValue) {
  if (minValue > maxValue) {
    // eslint-disable-next-line no-param-reassign
    var _ref = [maxValue, minValue];
    minValue = _ref[0];
    maxValue = _ref[1];
  }
  return Math.max(minValue, Math.min(value, maxValue));
};
export var omit = function omit(object, array) {
  // const mapObject = { ...object };
  var mapObject = Object.assign({}, object);
  array.forEach(function (key) {
    delete mapObject[key];
  });
  return mapObject;
};
/**
 * 移除非 Dom 属性的 props 的值
 * @param props 需要过滤 props 的属性
 * @param {string[]} invalidProps 需要从 props 过滤掉的不属于 dom 的属性.
 */
export function removeNonHTMLProps(props) {
  var invalidProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  // eslint-disable-next-line no-param-reassign
  invalidProps = invalidProps.concat(INVALID_PROPS);
  return omit(props, invalidProps);
}
/**获取IE浏览器版本 */
export var getIEVersion = function getIEVersion() {
  if (navigator) {
    var userAgent = navigator.userAgent;
    var ie11 = userAgent.indexOf('Trident') > -1 && userAgent.indexOf('rv:11.0') > -1;
    if (ie11) {
      return 11;
    }
    var versionArr = navigator.appVersion.split(';')[1];
    if (!versionArr) {
      return;
    }
    var version = versionArr.replace(/[ ]/g, '');
    var result = /MSIE(\d+)\./.exec(version);
    if (result) {
      return parseInt(result[1]);
    }
  }
};